题目

Some time ago Mister B detected a strange signal from the space, which he started to study.

After some transformation the signal turned out to be a permutation p of length n or its cyclic shift. For the further investigation Mister B need some basis, that's why he decided to choose cyclic shift of this permutation which has the minimum possible deviation.

Let's define the deviation of a permutation p as \(\Sigma^{i=n}_{i=1}|p[i]-i|\).

Find a cyclic shift of permutation p with minimum possible deviation. If there are multiple solutions, print any of them.

Let's denote id k \((0 ≤ k < n)\) of a cyclic shift of permutation p as the number of right shifts needed to reach this shift, for example:

\(k = 0: shift\ \ p_1, p_2, ... p_n,\)

\(k = 1: shift\ \ p_n, p_1, ... p_{n - 1},\)

\(...\)

\(k = n - 1: shift\ \ p_2, p_3, ... p_n, p_1.\)

输入格式

First line contains single integer \(n (2 ≤ n ≤ 106)\) — the length of the permutation.

The second line contains n space-separated integers \(p_1, p_2, ..., p_n (1 ≤ p_i ≤ n)\) — the elements of the permutation. It is guaranteed that all elements are distinct.

输出格式

Print two integers: the minimum deviation of cyclic shifts of permutation p and the id of such shift. If there are multiple solutions, print any of them.

样例

输入1

3
1 2 3

输出1

0 0

输入2

3
2 3 1

输出2

0 1

输入33

3
3 2 1

输出3

2 1

题解

如果纯模拟, 真的移动\(n\)次, 再加起来计算最小值, 复杂度太高, 需要一个\(O(n)\)的方法

很显然, 每次移动一位, 下标之间相差1, 可以看出规律来, 就是\(p[i]\)不变, 每次\(i\)增加\(1\), 超出范围的置为\(1\),

\(p[i] < i\)时, 随着移动, \(i\)逐渐变大, \(|p[i] - i|=i-p[i]\)逐渐变大, 当\(i\)超过\(n\)时, 重置为\(1\), 有可能变成第二种状态

\(p[i] > i\)时, 随着移动, \(i\)逐渐变大,\(|p[i] - i|=p[i] - i\)逐渐变小, 当移动到\(p[i] = i\)时, 转为第三种状态, 先记录下来\(p[i]\)与\(i\)最初的距离, 当移动次数与距离相等时, 转换状态

\(p[i] = i\)时, \(|p[i] - i|=0\), 再移动将会转为第一种状态.

最开始计算出所有数字之和, 根据移动次数, 处于三个状态的数字个数即可直接计算出现在的\(\Sigma^{i=n}_{i=1}|p[i]-i|\)

\(n\)次循环中, 取最小值输出

代码

#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e6 + 5;
long long p[maxn], has[maxn << 1];
int main() {
long long n, bigger = 0, smaller = 0, equ = 0, ans1 = 0, ans2 = 0;
scanf("%lld", &n);
for (long long i = 1ll; i <= n; i++) {
scanf("%lld", &p[i]);
if (p[i] > i) bigger++, has[p[i] - i]++;
else if (p[i] == i) equ++, has[0]++;
else smaller++;
ans1 += abs(p[i] - i);
}
long long temp = ans1;
for (long long last = n - 1ll, delta = 1ll; last >= 1ll; last--, delta++) {
temp += equ + smaller - bigger;
smaller += equ;
bigger -= has[delta];
if (p[last + 1] >= last + 1ll) has[p[last + 1] - last - 1]--;
has[p[last + 1] - 1 + delta]++;
equ = has[delta];
if (p[last + 1] > 1ll) bigger++;
smaller = n - equ - bigger;
temp -= abs(p[last + 1] - n - 1ll) - abs(p[last + 1] - 1ll);
if (temp < ans1) ans1 = temp, ans2 = delta;
}
printf("%lld %lld\n", ans1, ans2);
return 0;
}

CF819B Mister B and PR Shifts 题解的更多相关文章

  1. [CF819B]Mister B and PR Shifts

    题意:定义一个排列$p_{1\cdots n}$的“偏移量”$D=\sum _{i=1}^n\left|p_i-i\right|$ 求它所有的轮换排列中偏移量最小的是多少,要求输出轮换序数 暴力就是求 ...

  2. CF819B Mister B and PR Shifts 思维题

    分析 这道题\(n\leq10^{6}\),显然\(n^{2}\)的暴力是无法解决问题的 那么我们可以考虑数列的某一种性质 因为最终的答案是\(\sum{n \atop i=1} |p_i - i|\ ...

  3. Codeforces Round #421 (Div. 2) D. Mister B and PR Shifts

    Codeforces Round #421 (Div. 2) D. Mister B and PR Shifts 题意:给一个长度为\(n\)的排列,每次可以向右循环移位一次,计算\(\sum_{i= ...

  4. Mister B and PR Shifts,题解

    题目链接 分析: 题意很明白,不再多说了,直接分析题目,首先想一想暴力,直接枚举起点,然后求出来,时间复杂度n*n,显然不太好,所以我们考虑换一种方法枚举,当然本质还是枚举,其实你会发现变化i次和i+ ...

  5. codeforces 820 D. Mister B and PR Shifts(思维)

    题目链接:http://codeforces.com/contest/820/problem/D 题意:求.有一种操作 k = 0: shift p1, p2, ... pn, k = 1: shif ...

  6. D. Mister B and PR Shifts

    ;//开两倍空间 int n; arr p,cnt; int l,r,m; ll sum = ,ans; int main() { // file("test"); sdf(n); ...

  7. Codeforces Round #421 (Div. 2)D - Mister B and PR Shifts(模拟)

    传送门 题意 给出n个数,计算在进行n-1次右移中\(min\sum_{i=1}^nabs(p_i-i)\) 分析 我们设置cnt[p[i]-i]为一个数p[i]与它标准位置(如1的标准位置为1)的左 ...

  8. codeforces 819B - Mister B and PR Shifts(思维)

    原题链接:http://codeforces.com/problemset/problem/819/B 题意:把一个数列整体往右移k位(大于n位置的数移动到数列前端,循环滚动),定义该数列的“偏差值” ...

  9. CF820D Mister B and PR Shifts

    题目链接:http://codeforces.com/problemset/problem/820/D 题目大意: 给出一个\(n\)元素数组\(p[]\),定义数组\(p[]\)的误差值为\(\su ...

随机推荐

  1. 彻底搞懂 etcd 系列文章(二):etcd 的多种安装姿势

    0 专辑概述 etcd 是云原生架构中重要的基础组件,由 CNCF 孵化托管.etcd 在微服务和 Kubernates 集群中不仅可以作为服务注册与发现,还可以作为 key-value 存储的中间件 ...

  2. Centos网络配置文件详解

    配置文件位置: 根目录下面的etc下面的sysconfig下面的network-scripts下面的网卡名称配置文件. /etc/sysconfig/network-scripts/网卡名称 如图:我 ...

  3. 最新 iOS 框架整体梳理(二)

    在前面一篇中整理出来了一些了,下面的内容是接着上面一篇的接着整理.上篇具体的内容可以点击这里查看:   最新 iOS 框架整体梳理(一) Part - 2          34.CoreTeleph ...

  4. Android开发之修改Manifest中meta-data的数据

    代码 private void initFMMap() { ApplicationInfo appInfo = null; try { appInfo = this.getPackageManager ...

  5. HashMap源码和并发异常问题分析

    要点源码分析 HashMap允许键值对为null:HashTable则不允许,会报空指针异常: HashMap<String, String> map= new HashMap<&g ...

  6. 使用ssh连接数据库时出现Permission denied, please try again.解决方案

    安装ssh(如果已经安装则会覆盖)sudo apt-get install openssh-server找到/etc/ssh/sshd_config这个文件 将permitrootlogin的值设置为 ...

  7. Java内存溢出OutOfMemoryError的产生与排查

    在java的虚拟机异常中,有两个异常是大家比较关心的,一个是StackOverflowError,另一个是OutOfMemoryError.今天我们就来看看OutOfMemoryError是怎么产生的 ...

  8. SMB扫描-Server Message Block 协议、nmap

    版本 操作系统 SMB1 Windows 200.xp.2003 SMB2 Windows Vista SP1.2008 SMB2.1 Windows 7/2008 R2 SMB3 Windows 8 ...

  9. 用Map+函数式接口来实现策略模式

    用Map+函数式接口来实现策略模式 目前在魔都,贝壳找房是我的雇主,平时关注一些 java 领域相关的技术,希望你们能在这篇文章中找到些有用的东西.个人水平有限,如果文章有错误还请指出,在留言区一起交 ...

  10. 入门大数据---Hbase的SQL中间层_Phoenix

    一.Phoenix简介 Phoenix 是 HBase 的开源 SQL 中间层,它允许你使用标准 JDBC 的方式来操作 HBase 上的数据.在 Phoenix 之前,如果你要访问 HBase,只能 ...